unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls, StdCtrls, Registry, ComCtrls, Buttons, ShellApi;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Bevel2: TBevel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    Image1: TImage;
    e_host: TEdit;
    e_user: TEdit;
    e_pass: TEdit;
    Bevel3: TBevel;
    Label37: TLabel;
    Bevel4: TBevel;
    Label40: TLabel;
    Label41: TLabel;
    SpeedButton7: TSpeedButton;
    Shape1: TShape;
    SpeedButton3: TSpeedButton;
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure GetHost;
    procedure GetOSInfo;
    procedure ReadKeys;
    procedure ReadKeysActivate;
    procedure WriteKeys;
    procedure DeleteKeys;
    procedure Select;
    procedure Deselect;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);

  private
  host, user, pass, con_cmd, os, local_host,  s_syn, s_dgw, s_pmtu, s_kat,
  s_nnrod, s_tcpo, s_icmpr, s_ipsr, s_tcpmdr, s_tcpmpe, s_prd, s_thmo, s_thmor,
  s_tmcrr, s_fc, s_mf, s_aaar, s_amr: String;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// reads the keys out - on start-up
procedure TForm1.ReadKeysActivate;
var
  Registry: TRegistry;
begin
    Registry:=TRegistry.Create;
    Registry.RootKey:=HKEY_LOCAL_MACHINE;
    Registry.OpenKey('SYSTEM\CurrentControlSet\Services\Tcpip\Parameters',True);
    if (Registry.ValueExists('SynAttackProtect')) then
      s_syn    := IntToStr(Registry.ReadInteger('SynAttackProtect'));
    if (Registry.ValueExists('EnableDeadGWDetect')) then
      s_dgw    := IntToStr(Registry.ReadInteger('EnableDeadGWDetect'));
    if (Registry.ValueExists('EnablePMTUDiscovery')) then
      s_pmtu   := IntToStr(Registry.ReadInteger('EnablePMTUDiscovery'));
    if (Registry.ValueExists('KeepAliveTime')) then
      s_kat    := IntToStr(Registry.ReadInteger('KeepAliveTime'));
    if (Registry.ValueExists('NoNameReleaseOnDemand')) then
      s_nnrod  := IntToStr(Registry.ReadInteger('NoNameReleaseOnDemand'));
    if (Registry.ValueExists('Tcp1323Opts')) then
      s_tcpo   := IntToStr(Registry.ReadInteger('Tcp1323Opts'));
    if (Registry.ValueExists('EnableICMPRedirect')) then
      s_icmpr  := IntToStr(Registry.ReadInteger('EnableICMPRedirect'));
    if (Registry.ValueExists('DisableIPSourceRouting')) then
      s_ipsr   := IntToStr(Registry.ReadInteger('DisableIPSourceRouting'));
    if (Registry.ValueExists('TcpMaxDataRetransmissions')) then
      s_tcpmdr := IntToStr(Registry.ReadInteger('TcpMaxDataRetransmissions'));
    if (Registry.ValueExists('TCPMaxPortsExhausted')) then
      s_tcpmpe := IntToStr(Registry.ReadInteger('TCPMaxPortsExhausted'));
    if (Registry.ValueExists('PerformRouterDiscovery')) then
      s_prd    := IntToStr(Registry.ReadInteger('PerformRouterDiscovery'));
    if (Registry.ValueExists('TcpMaxHalfOpen')) then
      s_thmo   := IntToStr(Registry.ReadInteger('TcpMaxHalfOpen'));
    if (Registry.ValueExists('TcpMaxHalfOpenRetried')) then
      s_thmor  := IntToStr(Registry.ReadInteger('TcpMaxHalfOpenRetried'));
    if (Registry.ValueExists('TcpMaxConnectResponseRetransmissions')) then
      s_tmcrr  := IntToStr(Registry.ReadInteger('TcpMaxConnectResponseRetransmissions'));
    if (Registry.ValueExists('EnableFragmentChecking')) then
      s_fc     := IntToStr(Registry.ReadInteger('EnableFragmentChecking'));
    if (Registry.ValueExists('EnableMulticastForwarding')) then
      s_mf     := IntToStr(Registry.ReadInteger('EnableMulticastForwarding'));
    if (Registry.ValueExists('IPEnableRouter')) then
      s_aaar   := IntToStr(Registry.ReadInteger('IPEnableRouter'));
    if (Registry.ValueExists('EnableAddrMaskReply')) then
      s_amr    := IntToStr(Registry.ReadInteger('EnableAddrMaskReply'));
    Registry.Free;

  // make checkbox's unchecked
  CheckBox1.Checked  := false;
  CheckBox2.Checked  := false;
  CheckBox3.Checked  := false;
  CheckBox4.Checked  := false;
  CheckBox5.Checked  := false;
  CheckBox6.Checked  := false;
  CheckBox7.Checked  := false;
  CheckBox8.Checked  := false;
  CheckBox9.Checked  := false;
  CheckBox10.Checked := false;
  CheckBox11.Checked := false;
  CheckBox12.Checked := false;
  CheckBox13.Checked := false;
  CheckBox14.Checked := false;
  CheckBox15.Checked := false;
  CheckBox16.Checked := false;
  CheckBox17.Checked := false;
  CheckBox18.Checked := false;

  // set enable/disable
  if s_syn='2' then
   Label19.caption:='enabled'
  else
   begin
    Label19.Caption:='disabled';
    CheckBox1.Checked  := true;
   end;

  if s_dgw='0' then
   Label20.Caption:='enabled'
  else
   begin
    Label20.Caption:='disabled';
    CheckBox2.Checked  := true;
   end;

  if s_pmtu='0' then
   Label21.Caption:='enabled'
  else
   begin
    Label21.Caption:='disabled';
    CheckBox3.Checked  := true;
   end;

  if s_kat='300000' then
   Label22.Caption:='enabled'
  else
   begin
    Label22.Caption:='disabled';
    CheckBox4.Checked  := true;
   end;

  if s_nnrod='1' then
   Label23.Caption:='enabled'
  else
   begin
    Label23.Caption:='disabled';
    CheckBox5.Checked  := true;
   end;

  if s_tcpo='3' then
   Label24.Caption:='enabled'
  else
   begin
    Label24.Caption:='disabled';
    CheckBox6.Checked  := true;
   end;

  if s_icmpr='1' then
   Label25.Caption:='enabled'
  else
   begin
    Label25.Caption:='disabled';
    CheckBox7.Checked  := true;
   end;

  if s_ipsr='1' then
   Label26.Caption:='enabled'
  else
   begin
    Label26.Caption:='disabled';
    CheckBox8.Checked  := true;
   end;

  if s_tcpmdr='3' then
   Label27.Caption:='enabled'
  else
   begin
    Label27.Caption:='disabled';
    CheckBox9.Checked  := true;
   end;

  if s_tcpmpe='5' then
   Label28.Caption:='enabled'
  else
   begin
    Label28.Caption:='disabled';
    CheckBox10.Checked  := true;
   end;

  if s_prd='0' then
   Label29.Caption:='enabled'
  else
   begin
    Label29.Caption:='disabled';
    CheckBox11.Checked  := true;
   end;

  if s_thmo='100' then
   Label30.Caption:='enabled'
  else
   begin
    Label30.Caption:='disabled';
    CheckBox12.Checked  := true;
   end;

  if s_thmor='80' then
   Label31.Caption:='enabled'
  else
   begin
    Label31.Caption:='disabled';
    CheckBox13.Checked  := true;
   end;

  if s_tmcrr='5' then
   Label32.Caption:='enabled'
  else
   begin
    Label32.Caption:='disabled';
    CheckBox14.Checked  := true;
   end;

  if s_fc='1' then
   Label33.Caption:='enabled'
  else
   begin
    Label33.Caption:='disabled';
    CheckBox15.Checked  := true;
   end;

  if s_mf='1' then
   Label34.Caption:='enabled'
  else
   begin
    Label34.Caption:='disabled';
    CheckBox16.Checked  := true;
   end;

  if s_aaar='1' then
   Label35.Caption:='enabled'
  else
   begin
    Label35.Caption:='disabled';
    CheckBox17.Checked  := true;
   end;

  if s_amr='1' then
   Label36.Caption:='enabled'
  else
   begin
    Label36.Caption:='disabled';
    CheckBox18.Checked  := true;
   end;
end;

// selects all checkboxes
procedure TForm1.Select;
begin
 CheckBox1.Checked  := true;
 CheckBox2.Checked  := true;
 CheckBox3.Checked  := true;
 CheckBox4.Checked  := true;
 CheckBox5.Checked  := true;
 CheckBox6.Checked  := true;
 CheckBox7.Checked  := true;
 CheckBox8.Checked  := true;
 CheckBox9.Checked  := true;
 CheckBox10.Checked := true;
 CheckBox11.Checked := true;
 CheckBox12.Checked := true;
 CheckBox13.Checked := true;
 CheckBox14.Checked := true;
 CheckBox15.Checked := true;
 CheckBox16.Checked := true;
 CheckBox17.Checked := true;
 CheckBox18.Checked := true;
 checked := true;
end;

// deselects all checkboxes
procedure TForm1.Deselect;
begin
 CheckBox1.Checked  := false;
 CheckBox2.Checked  := false;
 CheckBox3.Checked  := false;
 CheckBox4.Checked  := false;
 CheckBox5.Checked  := false;
 CheckBox6.Checked  := false;
 CheckBox7.Checked  := false;
 CheckBox8.Checked  := false;
 CheckBox9.Checked  := false;
 CheckBox10.Checked := false;
 CheckBox11.Checked := false;
 CheckBox12.Checked := false;
 CheckBox13.Checked := false;
 CheckBox14.Checked := false;
 CheckBox15.Checked := false;
 CheckBox16.Checked := false;
 CheckBox17.Checked := false;
 CheckBox18.Checked := false;
 checked := false;
end;

procedure TForm1.ReadKeys;
var
  Registry: TRegistry;
begin
    Registry.OpenKey('SYSTEM\CurrentControlSet\Services\Tcpip\Parameters',True);
    if (Registry.ValueExists('SynAttackProtect')) then
      s_syn    := IntToStr(Registry.ReadInteger('SynAttackProtect'));
    if (Registry.ValueExists('EnableDeadGWDetect')) then
      s_dgw    := IntToStr(Registry.ReadInteger('EnableDeadGWDetect'));
    if (Registry.ValueExists('EnablePMTUDiscovery')) then
      s_pmtu   := IntToStr(Registry.ReadInteger('EnablePMTUDiscovery'));
    if (Registry.ValueExists('KeepAliveTime')) then
      s_kat    := IntToStr(Registry.ReadInteger('KeepAliveTime'));
    if (Registry.ValueExists('NoNameReleaseOnDemand')) then
      s_nnrod  := IntToStr(Registry.ReadInteger('NoNameReleaseOnDemand'));
    if (Registry.ValueExists('Tcp1323Opts')) then
      s_tcpo   := IntToStr(Registry.ReadInteger('Tcp1323Opts'));
    if (Registry.ValueExists('EnableICMPRedirect')) then
      s_icmpr  := IntToStr(Registry.ReadInteger('EnableICMPRedirect'));
    if (Registry.ValueExists('DisableIPSourceRouting')) then
      s_ipsr   := IntToStr(Registry.ReadInteger('DisableIPSourceRouting'));
    if (Registry.ValueExists('TcpMaxDataRetransmissions')) then
      s_tcpmdr := IntToStr(Registry.ReadInteger('TcpMaxDataRetransmissions'));
    if (Registry.ValueExists('TCPMaxPortsExhausted')) then
      s_tcpmpe := IntToStr(Registry.ReadInteger('TCPMaxPortsExhausted'));
    if (Registry.ValueExists('PerformRouterDiscovery')) then
      s_prd    := IntToStr(Registry.ReadInteger('PerformRouterDiscovery'));
    if (Registry.ValueExists('TcpMaxHalfOpen')) then
      s_thmo   := IntToStr(Registry.ReadInteger('TcpMaxHalfOpen'));
    if (Registry.ValueExists('TcpMaxHalfOpenRetried')) then
      s_thmor  := IntToStr(Registry.ReadInteger('TcpMaxHalfOpenRetried'));
    if (Registry.ValueExists('TcpMaxConnectResponseRetransmissions')) then
      s_tmcrr  := IntToStr(Registry.ReadInteger('TcpMaxConnectResponseRetransmissions'));
    if (Registry.ValueExists('EnableFragmentChecking')) then
      s_fc     := IntToStr(Registry.ReadInteger('EnableFragmentChecking'));
    if (Registry.ValueExists('EnableMulticastForwarding')) then
      s_mf     := IntToStr(Registry.ReadInteger('EnableMulticastForwarding'));
    if (Registry.ValueExists('IPEnableRouter')) then
      s_aaar   := IntToStr(Registry.ReadInteger('IPEnableRouter'));
    if (Registry.ValueExists('EnableAddrMaskReply')) then
      s_amr    := IntToStr(Registry.ReadInteger('EnableAddrMaskReply'));
    Registry.Free;

  // make checkbox's unchecked
  CheckBox1.Checked  := false;
  CheckBox2.Checked  := false;
  CheckBox3.Checked  := false;
  CheckBox4.Checked  := false;
  CheckBox5.Checked  := false;
  CheckBox6.Checked  := false;
  CheckBox7.Checked  := false;
  CheckBox8.Checked  := false;
  CheckBox9.Checked  := false;
  CheckBox10.Checked := false;
  CheckBox11.Checked := false;
  CheckBox12.Checked := false;
  CheckBox13.Checked := false;
  CheckBox14.Checked := false;
  CheckBox15.Checked := false;
  CheckBox16.Checked := false;
  CheckBox17.Checked := false;
  CheckBox18.Checked := false;

  // set enable/disable
  if s_syn='2' then
   Label19.caption:='enabled'
  else
   begin
    Label19.Caption:='disabled';
    CheckBox1.Checked  := true;
   end;

  if s_dgw='0' then
   Label20.Caption:='enabled'
  else
   begin
    Label20.Caption:='disabled';
    CheckBox2.Checked  := true;
   end;

  if s_pmtu='0' then
   Label21.Caption:='enabled'
  else
   begin
    Label21.Caption:='disabled';
    CheckBox3.Checked  := true;
   end;

  if s_kat='300000' then
   Label22.Caption:='enabled'
  else
   begin
    Label22.Caption:='disabled';
    CheckBox4.Checked  := true;
   end;

  if s_nnrod='1' then
   Label23.Caption:='enabled'
  else
   begin
    Label23.Caption:='disabled';
    CheckBox5.Checked  := true;
   end;

  if s_tcpo='3' then
   Label24.Caption:='enabled'
  else
   begin
    Label24.Caption:='disabled';
    CheckBox6.Checked  := true;
   end;

  if s_icmpr='1' then
   Label25.Caption:='enabled'
  else
   begin
    Label25.Caption:='disabled';
    CheckBox7.Checked  := true;
   end;

  if s_ipsr='1' then
   Label26.Caption:='enabled'
  else
   begin
    Label26.Caption:='disabled';
    CheckBox8.Checked  := true;
   end;

  if s_tcpmdr='3' then
   Label27.Caption:='enabled'
  else
   begin
    Label27.Caption:='disabled';
    CheckBox9.Checked  := true;
   end;

  if s_tcpmpe='5' then
   Label28.Caption:='enabled'
  else
   begin
    Label28.Caption:='disabled';
    CheckBox10.Checked  := true;
   end;

  if s_prd='0' then
   Label29.Caption:='enabled'
  else
   begin
    Label29.Caption:='disabled';
    CheckBox11.Checked  := true;
   end;

  if s_thmo='100' then
   Label30.Caption:='enabled'
  else
   begin
    Label30.Caption:='disabled';
    CheckBox12.Checked  := true;
   end;

  if s_thmor='80' then
   Label31.Caption:='enabled'
  else
   begin
    Label31.Caption:='disabled';
    CheckBox13.Checked  := true;
   end;

  if s_tmcrr='5' then
   Label32.Caption:='enabled'
  else
   begin
    Label32.Caption:='disabled';
    CheckBox14.Checked  := true;
   end;

  if s_fc='1' then
   Label33.Caption:='enabled'
  else
   begin
    Label33.Caption:='disabled';
    CheckBox15.Checked  := true;
   end;

  if s_mf='1' then
   Label34.Caption:='enabled'
  else
   begin
    Label34.Caption:='disabled';
    CheckBox16.Checked  := true;
   end;

  if s_aaar='1' then
   Label35.Caption:='enabled'
  else
   begin
    Label35.Caption:='disabled';
    CheckBox17.Checked  := true;
   end;

  if s_amr='1' then
   Label36.Caption:='enabled'
  else
   begin
    Label36.Caption:='disabled';
    CheckBox18.Checked  := true;
   end;
end;

procedure TForm1.GetOSInfo;
var
  Platform, os: string;
  BuildNumber: Integer;
begin
  case Win32Platform of
    VER_PLATFORM_WIN32_WINDOWS:
      begin
        Platform := 'Windows 95';
        BuildNumber := Win32BuildNumber and $0000FFFF;
      end;
    VER_PLATFORM_WIN32_NT:
      begin
        Platform := 'Windows NT';
        BuildNumber := Win32BuildNumber;
      end;
      else
      begin
        Platform := 'Windows';
        BuildNumber := 0;
      end;
  end;
  if (Win32Platform = VER_PLATFORM_WIN32_WINDOWS) or
     (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    if Win32CSDVersion = '' then
      os := Format('%s %d.%d (Build %d)', [Platform, Win32MajorVersion, Win32MinorVersion, BuildNumber])
    else
      os := Format('%s %d.%d (Build %d: %s)', [Platform, Win32MajorVersion, Win32MinorVersion, BuildNumber, Win32CSDVersion]);
  end
  else
    os := Format('%s %d.%d', [Platform, Win32MajorVersion, Win32MinorVersion]);
  StatusBar1.SimpleText := 'Your OS: ' + os;
end;

procedure TForm1.GetHost;
var
  Registry: TRegistry;
begin
  Registry:=TRegistry.Create;
  Registry.RootKey:=HKEY_LOCAL_MACHINE;
  Registry.OpenKey('SOFTWARE\Microsoft\Windows NT\CurrentVersion',true);
  local_host := Registry.ReadString('RegisteredOwner');
  Registry.Free;
  Label41.Caption := '\\' + local_host;
end;

procedure TForm1.WriteKeys;
var
  Registry: TRegistry;
begin
    Registry.OpenKey('SYSTEM\CurrentControlSet\Services\Tcpip\Parameters',True);
     if CheckBox1.Checked  then  Registry.WriteInteger('SynAttackProtect',2);
     if CheckBox2.Checked  then  Registry.WriteInteger('EnableDeadGWDetect',0);
     if CheckBox3.Checked  then  Registry.WriteInteger('EnablePMTUDiscovery',0);
     if CheckBox4.Checked  then  Registry.WriteInteger('KeepAliveTime',300000);
     if CheckBox5.Checked  then  Registry.WriteInteger('NoNameReleaseOnDemand',1);
     if CheckBox6.Checked  then  Registry.WriteInteger('Tcp1323Opts',3);
     if CheckBox7.Checked  then  Registry.WriteInteger('EnableICMPRedirect',1);
     if CheckBox8.Checked  then  Registry.WriteInteger('DisableIPSourceRouting',1);
     if CheckBox9.Checked  then  Registry.WriteInteger('TcpMaxDataRetransmissions',3);
     if CheckBox10.Checked then  Registry.WriteInteger('TCPMaxPortsExhausted',5);
     if CheckBox11.Checked then  Registry.WriteInteger('PerformRouterDiscovery',0);
     if CheckBox12.Checked then  Registry.WriteInteger('TcpMaxHalfOpen',100);
     if CheckBox13.Checked then  Registry.WriteInteger('TcpMaxHalfOpenRetried',80);
     if CheckBox14.Checked then  Registry.WriteInteger('TcpMaxConnectResponseRetransmissions',5);
     if CheckBox15.Checked then  Registry.WriteInteger('EnableFragmentChecking',1);
     if CheckBox16.Checked then  Registry.WriteInteger('EnableMulticastForwarding',1);
     if CheckBox17.Checked then  Registry.WriteInteger('IPEnableRouter',1);
     if CheckBox18.Checked then  Registry.WriteInteger('EnableAddrMaskReply',1);
    Registry.CloseKey;
    Registry.Free;
    ShowMessage('set keys - reboot required [tcp/ip stack reinitialisation]');
end;

procedure TForm1.DeleteKeys;
var
Registry : TRegistry;
begin
  Registry.OpenKey('SYSTEM\CurrentControlSet\Services\Tcpip\Parameters',true);
  if CheckBox1.Checked  then  Registry.DeleteValue('SynAttackProtect');
  if CheckBox2.Checked  then  Registry.DeleteValue('EnableDeadGWDetect');
  if CheckBox3.Checked  then  Registry.DeleteValue('EnablePMTUDiscovery');
  if CheckBox4.Checked  then  Registry.DeleteValue('KeepAliveTime');
  if CheckBox5.Checked  then  Registry.DeleteValue('NoNameReleaseOnDemand');
  if CheckBox6.Checked  then  Registry.DeleteValue('Tcp1323Opts');
  if CheckBox7.Checked  then  Registry.DeleteValue('EnableICMPRedirect');
  if CheckBox8.Checked  then  Registry.DeleteValue('DisableIPSourceRouting');
  if CheckBox9.Checked  then  Registry.DeleteValue('TcpMaxDataRetransmissions');
  if CheckBox10.Checked then  Registry.DeleteValue('TCPMaxPortsExhausted');
  if CheckBox11.Checked then  Registry.DeleteValue('PerformRouterDiscovery');
  if CheckBox12.Checked then  Registry.DeleteValue('TcpMaxHalfOpen');
  if CheckBox13.Checked then  Registry.DeleteValue('TcpMaxHalfOpenRetried');
  if CheckBox14.Checked then  Registry.DeleteValue('TcpMaxConnectResponseRetransmissions');
  if CheckBox15.Checked then  Registry.DeleteValue('EnableFragmentChecking');
  if CheckBox16.Checked then  Registry.DeleteValue('EnableMulticastForwarding');
  if CheckBox17.Checked then  Registry.DeleteValue('IPEnableRouter');
  if CheckBox18.Checked then  Registry.DeleteValue('EnableAddrMaskReply');
  Registry.Free;
  ShowMessage('keys deleted - reboot required [tcp/ip stack reinitialisation]');
end;

procedure TForm1.FormActivate(Sender: TObject);
var
  Registry: TRegistry;
begin
  ReadKeysActivate;
  GetHost;
  GetOSInfo;
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
var
  Registry: TRegistry;
begin
 host    := e_host.Text;
 user    := e_user.Text;
 pass    := e_pass.Text;
 con_cmd := 'use \\' + host + ' ' + pass + ' ' + '/user:' + user;
 ShellExecute(0, 'open', 'net.exe', PChar(con_cmd), '0', SW_HIDE);
 Registry := TRegistry.Create;
 Registry.RootKey := HKEY_LOCAL_MACHINE;
 if Registry.RegistryConnect('\\' + host) then
   begin
     ReadKeys;
     ShowMessage('connection established');
     Label41.Caption := '\\' + host;
   end
  else
  ShowMessage('connection failed');
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
 Registry: TRegistry;
begin
 host    := e_host.Text;
 user    := e_user.Text;
 pass    := e_pass.Text;
 con_cmd := 'use \\' + host + ' ' + pass + ' ' + '/user:' + user;
 ShellExecute(0, 'open', 'net.exe', PChar(con_cmd), '0', SW_HIDE);
 Registry := TRegistry.Create;
 Registry.RootKey := HKEY_LOCAL_MACHINE;
 Registry.RegistryConnect('\\' + host);
 WriteKeys;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var
 Registry: TRegistry;
begin
 host    := e_host.Text;
 user    := e_user.Text;
 pass    := e_pass.Text;
 con_cmd := 'use \\' + host + ' ' + pass + ' ' + '/user:' + user;
 ShellExecute(0, 'open', 'net.exe', PChar(con_cmd), '0', SW_HIDE);
 Registry := TRegistry.Create;
 Registry.RootKey := HKEY_LOCAL_MACHINE;
 Registry.RegistryConnect('\\' + host);
 DeleteKeys;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
 if SpeedButton3.Caption = 'select all' then
  begin
   Select;
   SpeedButton3.Caption := 'deselect all'
  end
 else
  begin
   Deselect;
   SpeedButton3.Caption := 'select all'
  end;
end;

end.
